import express from 'express';
import corsMiddleware from 'cors';
import { OptionsJson } from 'body-parser';
import { MiddlewareOptions as PlaygroundMiddlewareOptions } from 'graphql-playground-html';
import { ApolloServerBase } from 'apollo-server-core';
export { GraphQLOptions, GraphQLExtension } from 'apollo-server-core';
import { GraphQLOptions } from 'apollo-server-core';
export interface ServerRegistration {
    app: express.Application;
    path?: string;
    cors?: corsMiddleware.CorsOptions | boolean;
    bodyParserConfig?: OptionsJson | boolean;
    onHealthCheck?: (req: express.Request) => Promise<any>;
    disableHealthCheck?: boolean;
    gui?: boolean | PlaygroundMiddlewareOptions;
    uploads?: boolean | Record<string, any>;
}
export declare class ApolloServer extends ApolloServerBase {
    createGraphQLServerOptions(req: express.Request, res: express.Response): Promise<GraphQLOptions>;
    protected supportsSubscriptions(): boolean;
    applyMiddleware({ app, path, cors, bodyParserConfig, disableHealthCheck, gui, onHealthCheck, uploads, }: ServerRegistration): void;
}
export declare const registerServer: () => never;
